/**
 * NOTE: This class is auto generated by the swagger code generator program (1.0.11).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package fr.cea.kemanager.fhe.encrypt.restapi;

import java.io.IOException;
import java.nio.file.Path;
import java.util.List;
import java.util.Optional;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.vault.core.VaultTemplate;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import com.fasterxml.jackson.databind.ObjectMapper;

import fr.cea.kemanager.encrypt.models.EncryptObjectRequest;
import fr.cea.kemanager.fhe.encrypt.models.DposArrObj;
import fr.cea.kemanager.fhe.encrypt.models.ResultEncryptedData;
import fr.cea.kemanager.lib.DataObject;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.SpringCodegen", date = "2018-03-16T10:37:10.348Z")

@Api(value = "Data", description = "the Data API")
public interface FheCingulataApi {

	Logger log = LoggerFactory.getLogger(FheCingulataApi.class);
		
	//@Value("@{cea.fhe.analysis.model}")
	String FHE_ALGORITHM = "BLACK_LIST_FULL, BLACK_LIST_HIGH, BLACK_LIST_MEDIUM, BLACK_LIST_LOW"; 

    default Optional<ObjectMapper> getObjectMapper() {
        return Optional.empty();
    }
    
    default Optional<VaultTemplate> getVaultTemplate() {
        return Optional.empty();
    }

    default Optional<HttpServletRequest> getRequest() {
        return Optional.empty();
    }

    default Optional<String> getAcceptHeader() {
        return getRequest().map(r -> r.getHeader("Accept"));
    }

    @ApiOperation(value = "Homomorphic decryption of data using DSA Id and FHE model.", nickname = "decrypt", 
    			notes = "Data must be the content returned by the Homomorphic encryption API.", response = DataObject.class, tags={ "data", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = DataObject.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/decrypt/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}",
        produces = { "application/json" }, 
        consumes = { "multipart/form-data" },
        method = RequestMethod.POST)
    default ResponseEntity<DataObject> decrypt(    		
    		@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId,
    		@ApiParam(value = "",required=true, allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel, 
    		@ApiParam(value = "Ciphertext file") @Valid @RequestPart(value="cipherTextFile") MultipartFile cipherTextFile) {
    	if(getObjectMapper().isPresent() && getAcceptHeader().isPresent()) {
            if (getAcceptHeader().get().contains("application/json")) {
                try {
                    return null; 
                } catch (Exception e) {
                    log.error("Couldn't serialize response for content type application/json", e);
                    return new ResponseEntity<>(HttpStatus.INTERNAL_SERVER_ERROR);
                }
            }
        } else {
            log.warn("ObjectMapper or HttpServletRequest not configured in default DataApi interface so no example is generated");
        }
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);
    }


    @ApiOperation(value = "Encrypting your data in FHE format with necessary data inputs : DSA Id and FHE model", 
    		nickname = "encrypt",
    		notes = "Encrypting your data (like file CEF format for Black list analysis) in FHE format and stored them in local storage folder", 
    		response = String.class, 
    		tags={ "data", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = String.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class)})
    @RequestMapping(value = "/fhe/encrypt/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}/Analysis/{NeedAnalysis}",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.POST)
    default ResponseEntity<String> encrypt(
    		@ApiParam(value = "The CTI content to upload." ,required=true )  @Valid @RequestBody DataObject fileData,
    		@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId,
    		@ApiParam(value = "",required=true) @PathVariable("NeedAnalysis") boolean isNeedAnalysis,
    		@ApiParam(value = "",required=true, allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel) {
        if(getObjectMapper().isPresent() && getAcceptHeader().isPresent()) {
            if (getAcceptHeader().get().contains("application/json")) {
                try {
                    return null; //new ResponseEntity<>(getObjectMapper().get().readValue("{  \"message\" : \"notification from server\",  \"publishDate\" : \"2017-07-03T22:35:29.771\"}", ServerResponse.class), HttpStatus.NOT_IMPLEMENTED);
                } catch (Exception e) {
                    log.error("Couldn't serialize response for content type application/json", e);
                    return new ResponseEntity<>(HttpStatus.INTERNAL_SERVER_ERROR);
                }
            }
        } else {
            log.warn("ObjectMapper or HttpServletRequest not configured in default DataApi interface so no example is generated");
        }
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);
    }
    
    @ApiOperation(value = "Encrypting your data in FHE format with necessary data inputs : DSA Id and FHE model", 
    		nickname = "encryptCefFile",
    		notes = "Encrypting your data like CEF file for Black list analysis in FHE format and stored them in local storage folder", 
    		response = String.class, 
    		tags={ "data", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = DposArrObj.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class),
        @ApiResponse(code = 417, message = "Impossible to create VDL", response = String.class)})
    @RequestMapping(value = "/fhe/encrypt-cef/{RequestId}/dsa/{DSAId}/{extractField}/scheme/{FHEModel}",
    		produces = { "application/json" }, 
            consumes = { "multipart/form-data" },
        method = RequestMethod.POST)
    default ResponseEntity<DposArrObj> encryptCefFile(
    		@ApiParam(value = "The CEF content to upload", required=true) @RequestPart(value="cefFile") MultipartFile cefFile,
    		@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId,
    		@ApiParam(value = "",required=true) @PathVariable("extractField") String extractField,
    		@ApiParam(value = "",required=true, allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel) {
        if(getObjectMapper().isPresent() && getAcceptHeader().isPresent()) {
                try {
                    return null; //new ResponseEntity<>(getObjectMapper().get().readValue("{  \"message\" : \"notification from server\",  \"publishDate\" : \"2017-07-03T22:35:29.771\"}", ServerResponse.class), HttpStatus.NOT_IMPLEMENTED);
                } catch (Exception e) {
                    log.error("Couldn't serialize response for content type application/json", e);
                    return new ResponseEntity<>(HttpStatus.INTERNAL_SERVER_ERROR);
                }            
        } else {
            log.warn("ObjectMapper or HttpServletRequest not configured in default DataApi interface so no example is generated");
        }
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);
    }
    
    @ApiOperation(value = "Encrypting your data in FHE format with necessary data inputs : DSA Id and FHE model", 
    		nickname = "encryptLinkCefFile",
    		notes = "Encrypting your data like CEF file for Black list analysis in FHE format and stored them in local storage folder", 
    		response = String.class, 
    		tags={ "data", })
    @ApiResponses(value = { 
        @ApiResponse(code = 201, message = "DPOS IDs Created", response = DposArrObj.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class),
        @ApiResponse(code = 424, message = "Link to CEF file is not found", response = String.class),
        @ApiResponse(code = 500, message = "Internal error", response = String.class),
        @ApiResponse(code = 501, message = "Not implemented ", response = String.class)})       
    @RequestMapping(value = "/fhe/encrypt-cef-link",
            produces = { "application/json" }, 
            method = RequestMethod.POST)
    default ResponseEntity<DposArrObj> encryptLinkCefFile(
        		@ApiParam(value = "" ,required=true) @RequestHeader(value="DSAId", required=true) String dsAId,
        		@ApiParam(value = "The extractField src or dest" ,required=true) @RequestHeader(value="param", required=true) String param,
        		@ApiParam(value = "The FHE Analysis Model" ,required=true, allowableValues = FHE_ALGORITHM) @RequestHeader(value="option", required=true) String option,
        		@ApiParam(value = "link to CEF file" ) @RequestHeader(value="bufferLinkFile", required=false) String bufferLinkFile) {
            if(getObjectMapper().isPresent() && getAcceptHeader().isPresent()) {
                if (getAcceptHeader().get().contains("application/json")) {
                    return new ResponseEntity<>(new DposArrObj().success(false), HttpStatus.NOT_IMPLEMENTED);
                }
            } else {
                log.warn("ObjectMapper or HttpServletRequest not configured in default FheApi interface so no example is generated");
            }
            return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);
        }
    
    @ApiOperation(value = "Encrypting IP with inputs : DSA Id and FHE model", 
    		nickname = "encryptIp",
    		notes = "Encrypting ip in FHE format which was stored in local storage folder", 
    		response = ResultEncryptedData.class, 
    		tags={ "data", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = ResultEncryptedData.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/encrypt-ip/{ip}/{dsaId}/{FHEModel}",
        produces = { "application/json" }, 
        consumes = { "*" },
        method = RequestMethod.POST)
    default ResponseEntity<ResultEncryptedData> encryptIp(
    		@ApiParam(value = "",required=true) @PathVariable("ip") String ip,
    		@ApiParam(value = "",required=true) @PathVariable("dsaId") String dsaId,     		
    		@ApiParam(value = "",required=true, allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel) {
    	return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);        
    }
    
    @ApiOperation(value = "Encrypting IP with security lelvel :LOW, MEDIUM, HIGH, FULL", 
    		nickname = "encryptIpLvlSec",
    		notes = "Encrypting ip in FHE format with different security levels", 
    		response = ResultEncryptedData.class, 
    		tags={ "data", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = ResultEncryptedData.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/encrypt-ip-lvl-sec/{ip}/{dsaId}/{FHEModel}",
        produces = { "application/json" }, 
        consumes = { "*" },
        method = RequestMethod.POST)
    default ResponseEntity<ResultEncryptedData> encryptIpLvlSecurity(
    		@ApiParam(value = "",required=true) @PathVariable("ip") String ip,
    		@ApiParam(value = "",required=true) @PathVariable("dsaId") String dsaId,     		
    		@ApiParam(value = "",required=true, allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel) {
    	return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);        
    }
    
    
    @ApiOperation(value = "Encrypting your data in FHE format with necessary data inputs : DSA Id and FHE model", 
    		nickname = "getOutIpFromCEF",
    		notes = "Extraction IPs from your data (like file CEF format for Black list analysis) in function of field to extract", 
    		response = String.class, 
    		tags={ "data", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = List.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/get-out-ip/{extractField}",
        produces = { "application/json" }, 
        consumes = { "multipart/form-data" },
        method = RequestMethod.POST)
    default ResponseEntity<List<String>> getOutIpFromCEF(
    		@ApiParam(value = "The CEF content to upload", required=true) @RequestPart(value="cefFile") MultipartFile cefFile,
    		@ApiParam(value = "",required=true) @PathVariable("extractField") String extractField) {
        if(getObjectMapper().isPresent() && getAcceptHeader().isPresent()) {
            if (getAcceptHeader().get().contains("application/json")) {
                try {
                    return null; 
                } catch (Exception e) {
                    log.error("Couldn't serialize response for content type application/json", e);
                    return new ResponseEntity<>(HttpStatus.INTERNAL_SERVER_ERROR);
                }
            }
        } else {
            log.warn("ObjectMapper or HttpServletRequest not configured in default DataApi interface so no example is generated");
        }
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);
    }
    

    @ApiOperation(value = "Send FHE data from localhost storage to C3ISP storage and receiving DPO-ID", 
    		nickname = "invokeStorageFheData", 
    		notes = "Send FHE data from localhost storage to C3ISP storage by invoking DPO Storage with mandatory DSA Id and FHE model. "
    				+ "In the case of black list analysis, the data is encrypted IP. The response of this request is DPO-ID ", response = String.class, 
    		tags={ "data", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Sucessfull created", response = String.class),
        @ApiResponse(code = 201, message = "Created", response = String.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/invoke-storage-fhe-data/RequestId/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}",
        produces = { "*" },
        consumes = { "*" },
        method = RequestMethod.GET)
    ResponseEntity<String> invokeRemoteStorageFheData(    		    		
    		@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId,
    		@ApiParam(value = "",required=true, allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel);
    
    
    @ApiOperation(value = "Send FHE data from localhost storage and invoke Fully Homomorphic Encryption Analysis using DSA Id and FHE model", 
    		nickname = "invokeLocalDataToFheAnalysis", 
    		notes = "After checking static FHE database in remote server was created and encrypted data was already locally created, "
    				+ "this method allows sending these local encrypted data to IAI/FHE -Analysis and invoking FHE analysis service", 
    		response = String.class, 
    		tags={ "analysis", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Sucessfull created", response = String.class),
        @ApiResponse(code = 201, message = "Created", response = String.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/invoke-data-analysis/RequestId/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}",
        produces = { "application/json" },
        consumes = { "*" },
        method = RequestMethod.POST)
    ResponseEntity<String> invokeLocalDataToFheAnalysis(    		    		
    		@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId,
    		//@ApiParam(value = "The URL to get back analysis result DPO-ID" ,required=true )  @Valid @RequestBody String urlBack,
    		@ApiParam(value = "The URL to get back analysis result DPO-ID" ,required=true )  @Valid @RequestParam("urlBack") String urlBack,
    		@ApiParam(value = "",required=true, allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel);
    
    @ApiOperation(value = "Allow storing DPO-ID in the local database for decrypting later. In general case, this data contains the FHE Blacklist analysis", 
    		nickname = "storeDataObjectFheAnalysisId", 
    		notes = "A post method allows IAI/FHE-Analysis can send back the DPO-ID", response = String.class, 
    		tags={ "analysis", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Sucessfull created", response = String.class),
        @ApiResponse(code = 201, message = "Created", response = String.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/fhe-dpo-id/RequestId/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}",
        produces = { "application/json" },
        consumes = { "application/json" },
        method = RequestMethod.POST)
    ResponseEntity<String> storeDataObjectIDFromFheAnalysis(    		    		
    		@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId,
    		@ApiParam(value = "",required=true, allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel,
    		@ApiParam(value = "",required=true) @Valid @RequestBody String dpoID);
    		//@ApiParam(value = "",required=true) @Valid @RequestParam("dpoID") String dpoID);
    
    @ApiOperation(value = "Allow storing content DPO in the local database for decrypting later. In general case, this data contains the FHE Blacklist analysis", 
    		nickname = "storeDataContentObjectIDFromFheAnalysis", 
    		notes = "A post method allows IAI/FHE-Analysis can send back the FHE encrypted content ", response = String.class, 
    		tags={ "analysis", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Sucessfull created", response = String.class),
        @ApiResponse(code = 201, message = "Created", response = String.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/fhe-content-dpo/RequestId/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}",
        produces = { "application/json" },
        consumes = { "application/json" },
        method = RequestMethod.POST)
    ResponseEntity<String> storeDataContentObjectIDFromFheAnalysis(    		    		
    		@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId,
    		@ApiParam(value = "",required=true, allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel, 
    		@ApiParam(value = "",required=true) @Valid @RequestBody EncryptObjectRequest encryptedContentFile);
    
    
    @ApiOperation(value = "Transciphering the data encrypted with classical schem into FHE data format", nickname = "transEncryption", 
    		notes = "Transciphering to FHE format", response = DataObject.class, tags={ "transcryption", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = DataObject.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/transcryption/encrypt/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.POST)
    ResponseEntity<DataObject> transEncryption(
    		@ApiParam(value = "The CTI content to upload." ,required=true )  @Valid @RequestBody DataObject fileData,
    		@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId, 
    		@ApiParam(value = "The FHE Model" ,required=true )  @Valid @PathVariable("FHEModel") String FHEModel);
    
    
    @ApiOperation(value = "checking the data encrypted is existed ", nickname = "checkingResult", 
    		notes = "Checking data", response = String.class, tags={ "Result Analysis", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = String.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })   
    @RequestMapping(value="/fhe/checking/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}", method = RequestMethod.GET)
    ResponseEntity<String> checkingResult(    		
    		@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId, 
    		@ApiParam(value = "The FHE Model" ,required=true )  @Valid @PathVariable("FHEModel") String FHEModel);
    
    @ApiOperation(value = "decrypt the FHE data and send back the clear esponse", nickname = "getResult", 
    		notes = "Get back clear data", response = String.class, tags={ "Result Analysis", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = String.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })   
    @RequestMapping(value="/fhe/results/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}", method = RequestMethod.GET)
    ResponseEntity<String> getResult(    		
    		@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId, 
    		@ApiParam(value = "The FHE Model" ,required=true )  @Valid @PathVariable("FHEModel") String FHEModel);
}
